% Class Exercise Task Number 2
% Matlab Function
UpScaledData = resizem(grid_image,10,'bilinear');
figure;imagesc(UpScaledData); colormap(gray);

% My Own Implementation Of Upscaling
N = size(grid_image);
scale_factor = 10;

% New Image Grid
[X,Y] = meshgrid(1:scale_factor*N(1),1:scale_factor*N(2));
% New Image
UpScale = zeros(10*N);
% Interpolating the points from the grid_image to the new upscaled image
for i=1:size(UpScale,2)-2*scale_factor,
     for j=1:size(UpScale,2)-2*scale_factor,
        x = floor(i/scale_factor);
        y = floor(j/scale_factor);
        hx = (i - x*scale_factor)/scale_factor;
        hy = (j - y*scale_factor)/scale_factor;   
        indx = x+1;
        indy = y+1;
        Q00 = grid_image(indx,indy);
        Q10 = grid_image(indx+1,indy);
        Q01 = grid_image(indx,indy+1);
        Q11 = grid_image(indx+1,indy+1);        
        UpScale(i,j) = BiLinearIntepolation(Q00,Q01,Q10,Q11,hx,hy);
    end;
end;
%%

% To fill the rest of the image I Used the backward scheme
for i=size(UpScale,2):-1:size(UpScale,2)-2*scale_factor,
     for j=1:size(UpScale,2)-2*scale_factor,
        x = floor(i/scale_factor);
        y = floor(j/scale_factor);
        hx = (i - x*scale_factor)/scale_factor;
        hy = (j - y*scale_factor)/scale_factor;   
        indx = x;
        indy = y+1;
        Q00 = grid_image(indx-1,indy);
        Q10 = grid_image(indx,indy);
        Q01 = grid_image(indx-1,indy+1);
        Q11 = grid_image(indx,indy+1);
       UpScale(i,j) = BiLinearIntepolation(Q00,Q01,Q10,Q11,hx,hy);
    end;
end;
for i=1:size(UpScale,2)-2*scale_factor,
     for j=size(UpScale,2):-1:size(UpScale,2)-2*scale_factor,
        x = floor(i/scale_factor);
        y = floor(j/scale_factor);
        hx = (i - x*scale_factor)/scale_factor;
        hy = (j - y*scale_factor)/scale_factor;   
        indx = x+1;
        indy = y;
        Q00 = grid_image(indx,indy-1);
        Q10 = grid_image(indx+1,indy-1);
        Q01 = grid_image(indx,indy);
        Q11 = grid_image(indx+1,indy);
       UpScale(i,j) = BiLinearIntepolation(Q00,Q01,Q10,Q11,hx,hy);
    end;
end;


%% Translating Lena Image
clear all;
load AdditionalExercise4
I = double(lena);

% Defining the half-pixel translation vector
t = [2.5 2.5];
% Inverse translation
t_inv = -t;

N = size(I);
New_Size = N + ceil(t);

% New Image Grid
[X,Y] = meshgrid(New_Size);
% Creating the new Translated Image
default_pixel_value = 100;
New_Image = zeros(New_Size);

% Direct Transform

%%

% Inverse transform
for i=1:New_Size(1),
    for j=1:New_Size(2),
        point = [i j] + t_inv;
        % find nearest indexes
        indx = floor(point(1));
        indy = floor(point(2)); 
        if ( indx >= 2 && indx <= N(1)-1 && indy >= 2 && indy <= N(2)-1 )
            hx = point(1) - indx;
            hy = point(2) - indy;
            Q00 = I(indx,indy);
            Q10 = I(indx+1,indy);
            Q01 = I(indx,indy+1);
            Q11 = I(indx+1,indy+1);
            New_Image(i,j) = NearestNeighbour(Q00,Q01,Q10,Q11,hx,hy);
        else
            New_Image(i,j) = default_pixel_value;
        end;
    end;
end;

figure;
subplot(2,1,1); imagesc(I); colormap(gray); axis image;
subplot(2,1,2); imagesc(uint8(New_Image)); colormap(gray); axis image;